//
// Copyright (C) 2015 The Android Open Source Project
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#ifndef APMANAGER_MOCK_PROCESS_FACTORY_H_
#define APMANAGER_MOCK_PROCESS_FACTORY_H_

#include <base/lazy_instance.h>
#include <gmock/gmock.h>

#include "apmanager/process_factory.h"

namespace apmanager {

class MockProcessFactory : public ProcessFactory {
 public:
  ~MockProcessFactory() override;

  // This is a singleton. Use MockDHCPServerFactory::GetInstance()->Foo().
  static MockProcessFactory* GetInstance();

  MOCK_METHOD0(CreateProcess, brillo::Process*());

 protected:
  MockProcessFactory();

 private:
  friend struct base::DefaultLazyInstanceTraits<MockProcessFactory>;

  DISALLOW_COPY_AND_ASSIGN(MockProcessFactory);
};

}  // namespace apmanager

#endif  // APMANAGER_MOCK_PROCESS_FACTORY_H_
